SystemOrganization addCategory: #'Pier-TwitterAddons'!

PTComponent subclass: #PTHomeComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-TwitterAddons'!

!PTHomeComponent methodsFor: 'rendering' stamp: 'jmck 3/12/2010 14:58'!
renderEntry: aStatus on: html
	html image
		class: 'entry-user-image';
		src: aStatus user image.
	html span
		class: 'entry-user';
		with: aStatus user displayString , ': '.
	super renderEntry: aStatus on: html ! !

PRTwitterClient subclass: #PRTwitterHomeClient
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-TwitterAddons'!

!PRTwitterHomeClient class methodsFor: 'as yet unclassified' stamp: 'JohnMcKeon 2/27/2010 18:21'!
label
	^'Twitter Home Client'! !

!PRTwitterHomeClient methodsFor: 'accessing' stamp: 'JohnMcKeon 3/2/2010 18:17'!
children
	^Array with: self component! !

!PRTwitterHomeClient methodsFor: 'accessing' stamp: 'JohnMcKeon 3/2/2010 18:10'!
component
	^component ifNil: [ component := PTHomeComponent new ]! !

!PRTwitterHomeClient methodsFor: 'accessing' stamp: 'JohnMcKeon 3/2/2010 18:13'!
timeline
	^ self account home! !

PRTwitterHomeClient subclass: #PRTwitterTreeClient
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-TwitterAddons'!

!PRTwitterTreeClient class methodsFor: 'as yet unclassified' stamp: 'jmck 3/12/2010 09:24'!
descriptionHomeCount
	^MANumberDescription new
		accessor: #homeCount;
		label: 'Home Count';
		comment: 'Limit home timeline';
		default: 100;
		priority: 300;
		yourself! !

!PRTwitterTreeClient class methodsFor: 'as yet unclassified' stamp: 'JohnMcKeon 3/2/2010 19:39'!
label
	^'Twitter Pared Tree'! !

!PRTwitterTreeClient methodsFor: 'accessing' stamp: 'jmck 3/9/2010 21:20'!
component
	^component ifNil: [ component := PTParedTree new ]! !

!PRTwitterTreeClient methodsFor: 'accessing' stamp: 'jmck 3/12/2010 09:23'!
homeCount
	^self read: #descriptionHomeCount! !

!PRTwitterTreeClient methodsFor: 'rendering' stamp: 'jmck 3/12/2010 09:26'!
renderContentOn: html
	| timeline |
	timeline := self timeline.
	timeline isNil
		ifTrue: [ self component elements isEmpty
			ifTrue: [ ^ html heading level: 3; with: 'No results. Check username and password' ]]
		ifFalse: [ component := nil ].
	html render: (self component 
		tweets: (timeline first: (timeline size min: self homeCount))).
	"self showFollowing
		ifTrue: [ self renderFollowingOn: html ].
	self showFollowers
		ifTrue: [ self renderFollowersOn: html ]"! !

SUNavigation subclass: #PTParedTree
	instanceVariableNames: 'visible maxVisible'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-TwitterAddons'!

!PTParedTree class methodsFor: 'examples' stamp: 'JohnMcKeon 3/2/2010 16:38'!
example
	^ self new
		maxVisible: 2;
		add: SUCounterTest new label: 'Counter 1';
		add: SUCounterTest new label: 'Counter 2';
		add: SUCounterTest new label: 'Counter 3';
		yourself! !

!PTParedTree methodsFor: 'accessing' stamp: 'JohnMcKeon 3/2/2010 17:18'!
add: aComponent label: aString
	elements addFirst: aString -> aComponent! !

!PTParedTree methodsFor: 'accessing' stamp: 'JohnMcKeon 3/2/2010 16:37'!
cssClass
	^ 'accordion'! !

!PTParedTree methodsFor: 'accessing' stamp: 'JohnMcKeon 3/2/2010 20:18'!
elements
	^elements! !

!PTParedTree methodsFor: 'accessing' stamp: 'JohnMcKeon 3/2/2010 20:18'!
elements: aCollection
	elements := aCollection! !

!PTParedTree methodsFor: 'actions' stamp: 'JohnMcKeon 3/2/2010 16:37'!
hide: aComponent
	self visible remove: aComponent ifAbsent: [ ^ self ]! !

!PTParedTree methodsFor: 'initialization' stamp: 'JohnMcKeon 3/2/2010 16:37'!
initialize
	super initialize.
	visible := OrderedCollection new! !

!PTParedTree methodsFor: 'testing' stamp: 'jmck 3/8/2010 22:59'!
isVisible: aComponent
	^ self visible includes: aComponent! !

!PTParedTree methodsFor: 'accessing' stamp: 'JohnMcKeon 3/2/2010 16:37'!
maxVisible
	^ maxVisible! !

!PTParedTree methodsFor: 'accessing' stamp: 'JohnMcKeon 3/2/2010 16:37'!
maxVisible: anInteger
	maxVisible := anInteger! !

!PTParedTree methodsFor: 'rendering' stamp: 'jmck 3/9/2010 21:27'!
renderBody: aString component: aComponent index: anInteger on: html
	html div
		class: 'body';
		class: 'active' if: (self isVisible: aComponent);
		id: (self uid: 'body' at: anInteger);
		style: ((self isVisible: aComponent)
			ifFalse: [ 'display: none' ]);
		with: aComponent! !

!PTParedTree methodsFor: 'rendering' stamp: 'JohnMcKeon 3/2/2010 16:37'!
renderHead: aString component: aComponent index: anInteger on: html
	html div
		class: 'head';
		class: 'active' if: (self isVisible: aComponent);
		id: (self uid: 'head' at: anInteger);
		with: [
			html anchor
				onClick: (html evaluator
					callback: [ :script | self scriptToggle: aComponent on: script ];
					return: false);
				callback: [ self toggle: aComponent ];
				with: aString ]! !

!PTParedTree methodsFor: 'rendering' stamp: 'JohnMcKeon 3/2/2010 21:30'!
renderNavigationOn: html
	elements withIndexDo: [ :assoc :index |
		self
			renderHead: assoc key component: assoc value
			index: index on: html.
		self
			renderBody: assoc key component: assoc value
			index: index on: html ]! !

!PTParedTree methodsFor: 'scripting' stamp: 'JohnMcKeon 3/2/2010 16:37'!
scriptHide: aComponent  on: aScript
	| index |
	index := self findIndex: aComponent ifAbsent: [ ^ self ].
	aScript effect
		id: (self uid: 'body' at: index);
		blindUp.
	aScript element
		id: (self uid: 'body' at: index);
		removeClassName: 'active'.
	aScript element
		id: (self uid: 'head' at: index);
		removeClassName: 'active'! !

!PTParedTree methodsFor: 'scripting' stamp: 'JohnMcKeon 3/2/2010 16:37'!
scriptShow: aComponent on: aScript
	| index |
	index := self findIndex: aComponent ifAbsent: [ ^ self ].
	aScript effect
		id: (self uid: 'body' at: index);
		blindDown.
	aScript element
		id: (self uid: 'body' at: index);
		addClassName: 'active'.
	aScript element
		id: (self uid: 'head' at: index);
		addClassName: 'active'! !

!PTParedTree methodsFor: 'scripting' stamp: 'JohnMcKeon 3/2/2010 16:38'!
scriptToggle: aComponent on: aScript
	| previous |
	previous := self visible copy.
	self toggle: aComponent.
	(previous difference: self visible)
		do: [ :each | self scriptHide: each on: aScript ].
	(self visible difference: previous)
		do: [ :each | self scriptShow: each on: aScript ]! !

!PTParedTree methodsFor: 'actions' stamp: 'JohnMcKeon 3/2/2010 16:37'!
show: aComponent
	self visible addLast: aComponent.
	self maxVisible isNil ifFalse: [
		[ self maxVisible < self visible size ]
			whileTrue: [ self hide: self visible first ] ]! !

!PTParedTree methodsFor: 'actions' stamp: 'JohnMcKeon 3/2/2010 16:37'!
toggle: aComponent
	(self isVisible: aComponent)
		ifTrue: [ self hide: aComponent ]
		ifFalse: [ self show: aComponent ]! !

!PTParedTree methodsFor: 'accessing' stamp: 'jmck 3/12/2010 14:54'!
tweets: aCollection
	| user list label | 
	aCollection reversed do: [ :status |
			status user = user 
				ifFalse: [ list ifNotNil: [ 
					label := user displayString.
					list tweets size > 1 
						ifTrue: [ label := label , '(' ,  list tweets size asString , ')' ].
					self 
						add: list 
						label: label ].
					user := status user.
					list := PTComponent new ].
			list tweets addFirst: status ].
	! !

!PTParedTree methodsFor: 'accessing' stamp: 'JohnMcKeon 3/2/2010 16:37'!
visible
	^ visible! !
